"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.decode = void 0;
const ts_brand_json_1 = require("ts-brand-json");
const SetRootOperation_1 = require("../../../json-crdt-patch/operations/SetRootOperation");
const document_1 = require("../../document");
const ClockCodec_1 = require("./ClockCodec");
const decodeNode_1 = require("./decodeNode");
const decode = (packed) => {
    const data = ts_brand_json_1.JSON.parse(packed);
    const clockCodec = ClockCodec_1.ClockCodec.decode(data[0]);
    const doc = new document_1.Document(clockCodec.clock);
    let i = 1;
    const decodeTimestamp = () => clockCodec.decodeTs(data[i++], data[i++]);
    if (data[i]) {
        const id = decodeTimestamp();
        const node = decodeNode_1.decodeNode(doc, clockCodec, data[i++]);
        doc.root.insert(new SetRootOperation_1.SetRootOperation(id, node.id));
    }
    return doc;
};
exports.decode = decode;
