"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.encode = void 0;
const ClockCodec_1 = require("./ClockCodec");
const encode = (doc) => {
    const clockCodec = new ClockCodec_1.ClockCodec(doc.clock, new Map());
    const clockData = clockCodec.encode();
    const root = doc.root.last;
    let str = '[' + clockData;
    if (!root)
        str += ',0';
    else {
        const node = doc.nodes.get(root.value);
        str += ',' + clockCodec.encodeTs(root.id) + ',' + node.encodeCompact(clockCodec);
    }
    return str + ']';
};
exports.encode = encode;
