import type { ClockCodec } from '../../codec/compact/ClockCodec';
import { LogicalTimestamp } from '../../../json-crdt-patch/clock';
import { SetObjectKeysOperation } from '../../../json-crdt-patch/operations/SetObjectKeysOperation';
import { Document } from '../../document';
import { JsonNode } from '../../types';
import { json_string } from 'ts-brand-json';
export declare class ObjectType implements JsonNode {
    readonly doc: Document;
    readonly id: LogicalTimestamp;
    private readonly latest;
    constructor(doc: Document, id: LogicalTimestamp);
    get(key: string): undefined | LogicalTimestamp;
    getId(key: string): undefined | LogicalTimestamp;
    insert(op: SetObjectKeysOperation): void;
    put(key: string, id: LogicalTimestamp, value: LogicalTimestamp): void;
    toJson(): Record<string, unknown>;
    toString(tab?: string): string;
    clone(doc: Document): ObjectType;
    children(): IterableIterator<LogicalTimestamp>;
    encodeCompact(codec: ClockCodec): json_string<unknown[]>;
    static decodeCompact(doc: Document, codec: ClockCodec, data: unknown[]): ObjectType;
}
