import { JSON } from "ts-brand-json";
import { SetRootOperation } from "../../../json-crdt-patch/operations/SetRootOperation";
import { Document } from "../../document";
import { ClockCodec } from "./ClockCodec";
import { decodeNode } from "./decodeNode";
export const decode = (packed) => {
    const data = JSON.parse(packed);
    const clockCodec = ClockCodec.decode(data[0]);
    const doc = new Document(clockCodec.clock);
    let i = 1;
    const decodeTimestamp = () => clockCodec.decodeTs(data[i++], data[i++]);
    if (data[i]) {
        const id = decodeTimestamp();
        const node = decodeNode(doc, clockCodec, data[i++]);
        doc.root.insert(new SetRootOperation(id, node.id));
    }
    return doc;
};
