import { NULL, TRUE, FALSE, UNDEFINED } from "../../constants";
import { NumberType } from "../../types/lww-number/NumberType";
import { ObjectType } from "../../types/lww-object/ObjectType";
import { ArrayType } from "../../types/rga-array/ArrayType";
import { StringType } from "../../types/rga-string/StringType";
export const decodeNode = (doc, codec, data) => {
    switch (data) {
        case 1: return NULL;
        case 2: return TRUE;
        case 3: return FALSE;
        case 4: return UNDEFINED;
    }
    if (Array.isArray(data)) {
        switch (data[0]) {
            case 0: {
                const node = ObjectType.decodeCompact(doc, codec, data);
                doc.nodes.index(node);
                return node;
            }
            case 1: {
                const node = ArrayType.decodeCompact(doc, codec, data);
                doc.nodes.index(node);
                return node;
            }
            case 2: {
                const node = StringType.decodeCompact(doc, codec, data);
                doc.nodes.index(node);
                return node;
            }
            case 3: {
                const node = NumberType.decodeCompact(doc, codec, data);
                doc.nodes.index(node);
                return node;
            }
        }
    }
    throw new Error('UNKNOWN_NODE');
};
