import { ClockCodec } from "./ClockCodec";
export const encode = (doc) => {
    const clockCodec = new ClockCodec(doc.clock, new Map());
    const clockData = clockCodec.encode();
    const root = doc.root.last;
    let str = '[' + clockData;
    if (!root)
        str += ',0';
    else {
        const node = doc.nodes.get(root.value);
        str += ',' + clockCodec.encodeTs(root.id) + ',' + node.encodeCompact(clockCodec);
    }
    return str + ']';
};
