import type { json_string } from "ts-brand-json";
import type { LogicalTimestamp } from "../json-crdt-patch/clock";
import type { Identifiable } from "../json-crdt-patch/types";
import type { ClockCodec } from "./codec/compact/ClockCodec";
import type { Document } from "./document";
export interface JsonNode extends Identifiable {
    toJson(): unknown;
    clone(doc: Document): JsonNode;
    children(): IterableIterator<LogicalTimestamp>;
    encodeCompact(codec: ClockCodec): json_string<unknown>;
}
export interface JsonChunk extends Identifiable {
    span(): number;
}
