import type { JsonNode } from '../../types';
import type { Document } from '../../document';
import { LogicalTimestamp } from '../../../json-crdt-patch/clock';
import { SetNumberOperation } from '../../../json-crdt-patch/operations/SetNumberOperation';
import { json_string } from 'ts-brand-json';
import { ClockCodec } from '../../codec/compact/ClockCodec';
export declare class NumberType implements JsonNode {
    readonly id: LogicalTimestamp;
    writeId: LogicalTimestamp;
    value: number;
    constructor(id: LogicalTimestamp, writeId: LogicalTimestamp, value: number);
    insert(op: SetNumberOperation): void;
    toJson(): number;
    toString(tab?: string): string;
    clone(doc: Document): NumberType;
    children(): IterableIterator<LogicalTimestamp>;
    encodeCompact(codec: ClockCodec): json_string<unknown[]>;
    static decodeCompact(doc: Document, codec: ClockCodec, data: unknown[]): NumberType;
}
