export class NumberType {
    constructor(id, writeId, value) {
        this.id = id;
        this.writeId = writeId;
        this.value = value;
    }
    insert(op) {
        if (op.id.compare(this.writeId) <= 0)
            return;
        this.writeId = op.id;
        this.value = op.value;
    }
    toJson() {
        return this.value;
    }
    toString(tab = '') {
        return `${tab}num(${this.id.toString()}) { ${this.toJson()} }`;
    }
    clone(doc) {
        const num = new NumberType(this.id, this.writeId, this.value);
        return num;
    }
    *children() { }
    encodeCompact(codec) {
        const { id, writeId } = this;
        return '[3,' + codec.encodeTs(id) + ',' + codec.encodeTs(writeId) + ',' + this.value + ']';
    }
    static decodeCompact(doc, codec, data) {
        const id = codec.decodeTs(data[1], data[2]);
        const writeId = codec.decodeTs(data[3], data[4]);
        const obj = new NumberType(id, writeId, data[5]);
        return obj;
    }
}
