import { LogicalTimestamp } from '../../../json-crdt-patch/clock';
export class ArrayChunk {
    constructor(id, values) {
        this.id = id;
        this.values = values;
        this.left = null;
        this.right = null;
    }
    span() {
        return this.deleted || this.values.length;
    }
    split(time) {
        const newSpan = 1 + time - this.id.time;
        const newId = new LogicalTimestamp(this.id.sessionId, time + 1);
        if (this.values) {
            const newChunkValues = this.values.splice(newSpan);
            return new ArrayChunk(newId, newChunkValues);
        }
        else {
            const chunk = new ArrayChunk(newId, undefined);
            chunk.deleted = this.span() - newSpan;
            this.deleted = newSpan;
            return chunk;
        }
    }
    delete() {
        this.deleted = this.span();
        delete this.values;
    }
    merge(values) {
        this.values.push(...values);
    }
    clone() {
        const chunk = new ArrayChunk(this.id, this.values);
        if (this.deleted) {
            chunk.deleted = this.deleted;
            delete this.values;
        }
        return chunk;
    }
    toString(tab = '') {
        let str = `${tab}ArrayChunk(${this.id.toDisplayString()}) { ${!this.values ? `[${this.deleted || 0}]` : this.values.map(val => val.toString()).join(', ')} }`;
        return str;
    }
}
