import type { JsonNode } from '../../types';
import type { Document } from '../../document';
import type { json_string } from 'ts-brand-json';
import { LogicalTimespan, LogicalTimestamp } from '../../../json-crdt-patch/clock';
import { DeleteOperation } from '../../../json-crdt-patch/operations/DeleteOperation';
import { InsertArrayElementsOperation } from '../../../json-crdt-patch/operations/InsertArrayElementsOperation';
import { ArrayChunk } from './ArrayChunk';
import { ClockCodec } from '../../codec/compact/ClockCodec';
export declare class ArrayType implements JsonNode {
    readonly doc: Document;
    readonly id: LogicalTimestamp;
    start: ArrayChunk;
    end: ArrayChunk;
    constructor(doc: Document, id: LogicalTimestamp);
    insert(op: InsertArrayElementsOperation): void;
    private insertChunk;
    private splitChunk;
    delete(op: DeleteOperation): void;
    private deleteInChunk;
    findId(index: number): LogicalTimestamp;
    findValue(index: number): LogicalTimestamp;
    findIdSpans(index: number, length: number): LogicalTimespan[];
    toJson(): unknown[];
    clone(doc: Document): ArrayType;
    children(): IterableIterator<LogicalTimestamp>;
    toString(tab?: string): string;
    encodeCompact(codec: ClockCodec): json_string<unknown[]>;
    static decodeCompact(doc: Document, codec: ClockCodec, data: unknown[]): ArrayType;
}
