import type { LogicalTimestamp } from './clock';
import { DeleteOperation } from './operations/DeleteOperation';
import { InsertArrayElementsOperation } from './operations/InsertArrayElementsOperation';
import { InsertStringSubstringOperation } from "./operations/InsertStringSubstringOperation";
import { MakeArrayOperation } from "./operations/MakeArrayOperation";
import { MakeConstantOperation } from './operations/MakeConstantOperation';
import { MakeNumberOperation } from "./operations/MakeNumberOperation";
import { MakeObjectOperation } from "./operations/MakeObjectOperation";
import { MakeStringOperation } from "./operations/MakeStringOperation";
import { NoopOperation } from './operations/NoopOperation';
import { SetNumberOperation } from './operations/SetNumberOperation';
import { SetObjectKeysOperation } from "./operations/SetObjectKeysOperation";
import { SetRootOperation } from "./operations/SetRootOperation";
export declare type JsonCrdtPatchOperation = DeleteOperation | InsertArrayElementsOperation | InsertStringSubstringOperation | MakeArrayOperation | MakeNumberOperation | MakeObjectOperation | MakeStringOperation | MakeConstantOperation | SetObjectKeysOperation | SetRootOperation | SetNumberOperation | NoopOperation;
export declare class Patch {
    readonly ops: JsonCrdtPatchOperation[];
    constructor();
    getId(): LogicalTimestamp | undefined;
    span(): number;
    nextTime(): number;
}
