"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClockEncoder = void 0;
var RelativeTimestamp_1 = require("./RelativeTimestamp");
var ClockEncoder = (function () {
    function ClockEncoder(clock) {
        this.clock = clock;
        this.index = 1;
        this.table = new Map();
        this.table.set(clock.sessionId, this.index++);
    }
    ClockEncoder.prototype.append = function (ts) {
        var sessionId = ts.sessionId, time = ts.time;
        if (sessionId === 0)
            return new RelativeTimestamp_1.RelativeTimestamp(0, ts.time);
        var clock = this.clock.clocks.get(sessionId);
        if (!clock)
            throw new Error("Clock not found (" + sessionId + ", " + time + ").");
        if (!this.table.has(sessionId))
            this.table.set(sessionId, this.index++);
        var sessionIndex = this.table.get(sessionId);
        var timeDiff = clock.time - time;
        var relativeTimestamp = new RelativeTimestamp_1.RelativeTimestamp(sessionIndex, timeDiff);
        return relativeTimestamp;
    };
    return ClockEncoder;
}());
exports.ClockEncoder = ClockEncoder;
