"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClockCodec = void 0;
var tslib_1 = require("tslib");
var clock_1 = require("../../../json-crdt-patch/clock");
var ClockCodec = (function () {
    function ClockCodec(clock, table1) {
        this.clock = clock;
        this.table2 = new Map();
        this.table1 = table1;
    }
    ClockCodec.prototype.encode = function () {
        var e_1, _a;
        var clock = this.clock;
        var str = '[' + clock.sessionId + ',' + clock.time;
        this.table2.set(clock.sessionId, 1);
        var i = 2;
        try {
            for (var _b = tslib_1.__values(clock.clocks.values()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (c.sessionId !== clock.sessionId) {
                    str += ',' + c.sessionId + ',' + c.time;
                    this.table2.set(c.sessionId, i++);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return str + ']';
    };
    ClockCodec.decode = function (data) {
        var table1 = new Map();
        var _a = tslib_1.__read(data, 2), sessionId = _a[0], time = _a[1];
        var clock = new clock_1.VectorClock(sessionId, time);
        table1.set(1, clock);
        var length = data.length;
        var j = 2;
        var i = 2;
        while (i < length) {
            var sessionId_1 = data[i++];
            var time_1 = data[i++];
            var timestamp = new clock_1.LogicalTimestamp(sessionId_1, time_1);
            table1.set(j++, timestamp);
            clock.observe(timestamp, 1);
        }
        return new ClockCodec(clock, table1);
    };
    ClockCodec.prototype.encodeTs = function (ts) {
        var sessionId = ts.sessionId, time = ts.time;
        var clockId = this.table2.get(sessionId);
        if (!clockId)
            return sessionId + ',' + time;
        var clock = this.clock.clocks.get(sessionId);
        return clockId + ',' + (clock.time - time);
    };
    ClockCodec.prototype.decodeTs = function (clockId, time) {
        var clock = this.table1.get(clockId);
        if (!clock)
            return new clock_1.LogicalTimestamp(clockId, time);
        return new clock_1.LogicalTimestamp(clock.sessionId, clock.time - time);
    };
    return ClockCodec;
}());
exports.ClockCodec = ClockCodec;
