"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.decode = void 0;
var ts_brand_json_1 = require("ts-brand-json");
var SetRootOperation_1 = require("../../../json-crdt-patch/operations/SetRootOperation");
var document_1 = require("../../document");
var ClockCodec_1 = require("./ClockCodec");
var decodeNode_1 = require("./decodeNode");
var decode = function (packed) {
    var data = ts_brand_json_1.JSON.parse(packed);
    var clockCodec = ClockCodec_1.ClockCodec.decode(data[0]);
    var doc = new document_1.Document(clockCodec.clock);
    var i = 1;
    var decodeTimestamp = function () { return clockCodec.decodeTs(data[i++], data[i++]); };
    if (data[i]) {
        var id = decodeTimestamp();
        var node = decodeNode_1.decodeNode(doc, clockCodec, data[i++]);
        doc.root.insert(new SetRootOperation_1.SetRootOperation(id, node.id));
    }
    return doc;
};
exports.decode = decode;
