"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeNode = void 0;
var constants_1 = require("../../constants");
var NumberType_1 = require("../../types/lww-number/NumberType");
var ObjectType_1 = require("../../types/lww-object/ObjectType");
var ArrayType_1 = require("../../types/rga-array/ArrayType");
var StringType_1 = require("../../types/rga-string/StringType");
var decodeNode = function (doc, codec, data) {
    switch (data) {
        case 1: return constants_1.NULL;
        case 2: return constants_1.TRUE;
        case 3: return constants_1.FALSE;
        case 4: return constants_1.UNDEFINED;
    }
    if (Array.isArray(data)) {
        switch (data[0]) {
            case 0: {
                var node = ObjectType_1.ObjectType.decodeCompact(doc, codec, data);
                doc.nodes.index(node);
                return node;
            }
            case 1: {
                var node = ArrayType_1.ArrayType.decodeCompact(doc, codec, data);
                doc.nodes.index(node);
                return node;
            }
            case 2: {
                var node = StringType_1.StringType.decodeCompact(doc, codec, data);
                doc.nodes.index(node);
                return node;
            }
            case 3: {
                var node = NumberType_1.NumberType.decodeCompact(doc, codec, data);
                doc.nodes.index(node);
                return node;
            }
        }
    }
    throw new Error('UNKNOWN_NODE');
};
exports.decodeNode = decodeNode;
