"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberType = void 0;
var tslib_1 = require("tslib");
var NumberType = (function () {
    function NumberType(id, writeId, value) {
        this.id = id;
        this.writeId = writeId;
        this.value = value;
    }
    NumberType.prototype.insert = function (op) {
        if (op.id.compare(this.writeId) <= 0)
            return;
        this.writeId = op.id;
        this.value = op.value;
    };
    NumberType.prototype.toJson = function () {
        return this.value;
    };
    NumberType.prototype.toString = function (tab) {
        if (tab === void 0) { tab = ''; }
        return tab + "num(" + this.id.toString() + ") { " + this.toJson() + " }";
    };
    NumberType.prototype.clone = function (doc) {
        var num = new NumberType(this.id, this.writeId, this.value);
        return num;
    };
    NumberType.prototype.children = function () { return tslib_1.__generator(this, function (_a) {
        return [2];
    }); };
    NumberType.prototype.encodeCompact = function (codec) {
        var _a = this, id = _a.id, writeId = _a.writeId;
        return '[3,' + codec.encodeTs(id) + ',' + codec.encodeTs(writeId) + ',' + this.value + ']';
    };
    NumberType.decodeCompact = function (doc, codec, data) {
        var id = codec.decodeTs(data[1], data[2]);
        var writeId = codec.decodeTs(data[3], data[4]);
        var obj = new NumberType(id, writeId, data[5]);
        return obj;
    };
    return NumberType;
}());
exports.NumberType = NumberType;
