"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayChunk = void 0;
var tslib_1 = require("tslib");
var clock_1 = require("../../../json-crdt-patch/clock");
var ArrayChunk = (function () {
    function ArrayChunk(id, values) {
        this.id = id;
        this.values = values;
        this.left = null;
        this.right = null;
    }
    ArrayChunk.prototype.span = function () {
        return this.deleted || this.values.length;
    };
    ArrayChunk.prototype.split = function (time) {
        var newSpan = 1 + time - this.id.time;
        var newId = new clock_1.LogicalTimestamp(this.id.sessionId, time + 1);
        if (this.values) {
            var newChunkValues = this.values.splice(newSpan);
            return new ArrayChunk(newId, newChunkValues);
        }
        else {
            var chunk = new ArrayChunk(newId, undefined);
            chunk.deleted = this.span() - newSpan;
            this.deleted = newSpan;
            return chunk;
        }
    };
    ArrayChunk.prototype.delete = function () {
        this.deleted = this.span();
        delete this.values;
    };
    ArrayChunk.prototype.merge = function (values) {
        var _a;
        (_a = this.values).push.apply(_a, tslib_1.__spreadArray([], tslib_1.__read(values)));
    };
    ArrayChunk.prototype.clone = function () {
        var chunk = new ArrayChunk(this.id, this.values);
        if (this.deleted) {
            chunk.deleted = this.deleted;
            delete this.values;
        }
        return chunk;
    };
    ArrayChunk.prototype.toString = function (tab) {
        if (tab === void 0) { tab = ''; }
        var str = tab + "ArrayChunk(" + this.id.toDisplayString() + ") { " + (!this.values ? "[" + (this.deleted || 0) + "]" : this.values.map(function (val) { return val.toString(); }).join(', ')) + " }";
        return str;
    };
    return ArrayChunk;
}());
exports.ArrayChunk = ArrayChunk;
